// Ex0604: フォトインタラプタ(マクロ定義，配列，forループ)
#define NUM_PR  5 // センサの数
const int pr_pins[NUM_PR] = {A3, A6, A7, A4, A5}; // ピン定義
int pr[NUM_PR] = {0};
int pr_bin[NUM_PR] = {0}; // ラインの有無
const int PR_TH = 3000; // 閾値

void setup() {
  Serial.begin(115200);
  delay(100);
}

void loop() {
  get_pr(); // センサの値取得，閾値処理

  // 実行結果の表示
  for (int i = 0; i < NUM_PR; i++) {
    Serial.print(pr_bin[i]);
    if (i < NUM_PR-1)
      Serial.print(",");
  }
  Serial.println();

  delay(100);
}

void get_pr() {
  // センサの値を取得
  for (int i = 0; i < NUM_PR; i++) {
    pr[i] = analogRead(pr_pins[i]);
  }
  // 閾値処理
  for (int i = 0; i < NUM_PR; i++) {
    if (pr[i] > PR_TH) {
      pr_bin[i] = 1;
    } else {
      pr_bin[i] = 0;
    }
  }
}
