// Ex0605: ラインの位置検出(ラインなし0,ラインあり100-500)
#define NUM_PR  5 // センサの数
const int pr_pins[NUM_PR] = {A3, A6, A7, A4, A5};
int pr[NUM_PR] = {0};
int pr_bin[NUM_PR] = {0}; // ラインの有無
const int PR_TH = 3000; // 閾値
unsigned long pr_time = 0; // フォトインタラプタ用タイマー計測値

void setup() {
  Serial.begin(115200);
  delay(100);
}

void loop() {
  if (millis() - pr_time > 100) { // 100ms毎に実行
    pr_time = millis();
    get_pr();
    for (int i = 0; i < NUM_PR; i++) {
      Serial.print(pr_bin[i]);
      Serial.print(",");
    }
    Serial.println(line_pos());
  }
}

void get_pr() {
  // センサの値を取得
  for (int i = 0; i < NUM_PR; i++) {
    pr[i] = analogRead(pr_pins[i]);
  }
  // 閾値処理
  for (int i = 0; i < NUM_PR; i++) {
    if (pr[i] > PR_TH) {
      pr_bin[i] = 1;
    } else {
      pr_bin[i] = 0;
    }
  }
}

// LEFT-----------CENTER-----------RIGHT
// 100,150,200,250,<300>,350,400,450,500
// OUT of LINE: 0
int line_pos() {
  int pos;
  int sum = 0, n = 0;
  for (int i = 0; i < 5; i++) {
    sum += pr_bin[i] * ((i + 1) * 100); // 重み付け計算
    if (pr_bin[i] == 1) n++; // ラインを検出した数
  }

  if (n > 0) {
    pos = sum / n;
  } else {
    pos = 0;
  }

  return pos;
}
