// Ex0606: フォトインタラプタ(最大，最小)
#define NUM_PR  5 // センサの数
const int pr_pins[NUM_PR] = {A3, A6, A7, A4, A5}; // ピン定義
int pr[NUM_PR] = {0};
int pr_bin[NUM_PR] = {0}; // ラインの有無
int pr_min[NUM_PR] = {4095, 4095, 4095, 4095, 4095}; // 最小値
int pr_max[NUM_PR] = {0}; // 最大値
const int PR_TH = 3000; // 閾値
long pr_time = 0; // フォトインタラプタ用タイマー計測値

void setup() {
  Serial.begin(115200);
  delay(100);
}

void loop() {
  if (millis() - pr_time > 100) { // 100ms毎に実行
    pr_time = millis();
    get_pr(); // センサの値取得，閾値処理

    // 実行結果の表示
    pr_print_minmax();
  }
}

void get_pr() {
  // センサの値を取得
  for (int i = 0; i < NUM_PR; i++) {
    pr[i] = analogRead(pr_pins[i]);
  }
  // 最小，最大
  for (int i = 0; i < NUM_PR; i++) {
    if (pr[i] < pr_min[i]) pr_min[i] = pr[i];
    if (pr[i] > pr_max[i]) pr_max[i] = pr[i];
  }
  // 閾値処理
  for (int i = 0; i < NUM_PR; i++) {
    if (pr[i] > PR_TH) {
      pr_bin[i] = 1;
    } else {
      pr_bin[i] = 0;
    }
  }
}

void pr_print_minmax() {
  Serial.print("int pr_min[PR_NUM] = {");
  for (int i = 0; i < NUM_PR; i++) {
    Serial.print(pr_min[i]);
    if (i < NUM_PR - 1) Serial.print(",");
  }
  Serial.println("};");

  Serial.print("int pr_max[PR_NUM] = {");
  for (int i = 0; i < NUM_PR; i++) {
    Serial.print(pr_max[i]);
    if (i < NUM_PR - 1) Serial.print(",");
  }
  Serial.println("};");
}
